
*.............................................................................
*
*   Program Name: DBCALNDR.DFM        Copyright: Borland International
*   Date Created: 28 Mar 94            Language: dBASE 5.0
*   Time Created: 13:30:00               Author: Borland dBASE R&D
*   /brief/library.src
*.............................................................................

    * define the calendar form
    DEFINE FORM dbCalndr;
        PROPERTY ;
            HEIGHT       13,;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            KEY          CheckArw,;
            LEFT          2,;
            MDI         .F.,;
            WIDTH        32,;
            ONGOTFOCUS   SetTalk,;
            ONLOSTFOCUS  ResetTalk,;
            ONCLICK      CheckArw,;
            TEXT        [Calendar],;
            TOP           1;
            CUSTOM;
                cMyStr   " ",;
                dFirst    {},;
                dLast     {},;
                nDay       0,;
                nMth       0,;  
                nYear      0,;
                lSTalk   .T.,;
                nDateFmt   0,;
                dNewDate  {}

    * define the menu bar
    DEFINE MENUBAR mCal OF m->dbCalndr

    * define the File menu
    DEFINE MENU mFile OF dbCalndr.mCal;
        PROPERTY ;
            STATUSMESSAGE [File operations],;
            TEXT [&File]

    * define the Exit option of the file menu
    DEFINE MENUITEM mExit OF dbCalndr.mCal.mFile;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK        CalExit,;
            SHORTCUT      "ALT-F4",;
            STATUSMESSAGE [Exit the calendar],;
            TEXT          [E&xit]
            
    * define the Edit menu
    DEFINE MENU mEdit OF dbCalndr.mCal;
        PROPERTY ;   
            STATUSMESSAGE [Edit operations],;
            TEXT [&Edit]

    * define the Copy option of the edit menu
    DEFINE MENUITEM mCopy OF dbCalndr.mCal.mEdit;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK        CopyDate,;
            SHORTCUT      "CTRL-INS",;
            STATUSMESSAGE [Copy the current date to the clipboard using the current date format],;
            TEXT          [&Copy]
            
    * define the first seperator
    DEFINE MENUITEM mSep1 OF dbCalndr.mCal.mEdit PROPERTY TEXT ""

    * define the goto today option of the edit menu    
    DEFINE MENUITEM mToday OF dbCAlndr.mCal.mEdit;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK        GoToday,;
            STATUSMESSAGE [Move the calendar to today's date],;
            TEXT          [&Today]            

    * define the previous month option of the edit menu
    DEFINE MENUITEM mPrev OF dbCalndr.mCal.mEdit;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK        PrevMth,;
            SHORTCUT      "PGUP",;
            STATUSMESSAGE [Move the calendar to the previous month],;
            TEXT          [&Previous]

    * define the next month option of the edit menu
    DEFINE MENUITEM mNext OF dbCalndr.mCal.mEdit;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK        NextMth,;
            SHORTCUT      "PGDN",;
            STATUSMESSAGE [Move the calendar to the next month],;
            TEXT          [&Next]

    * define the set date option of the edit menu
    DEFINE MENUITEM mSetDate OF dbCalndr.mCal.mEdit;
        PROPERTY ;
            HELPFILE    "DBASE1.HLP",;
            HELPID      "20511",;
            ONCLICK      SetDate,;
            STATUSMESSAGE [Enter a date for the calendar to move to],;
            TEXT          [&Set date...]

    * define the Options menu
    DEFINE MENU mOption OF dbCalndr.mCal;
        PROPERTY ;   
            STATUSMESSAGE [Set calendar options],;
            TEXT [&Options]

    * define the date format bars
    DEFINE MENUITEM mDFrmt OF dbCalndr.mCal.mOption;
        PROPERTY ;
            HELPFILE      "DBASE1.HLP",;
            HELPID        "20512",;
            ONCLICK        DateFrmt,;
            ONHELP         IDEHelp,;
            STATUSMESSAGE [Set the format for dates when copied to the clipboard],;
            TEXT          [&Date format...]

    * define help menu
    DEFINE MENU mHelp OF dbCalndr.mCal;
        PROPERTY ;   
            STATUSMESSAGE [Get help with the calendar],;
            TEXT [&Help]

    * define the using option of the help menu
    DEFINE MENUITEM mUsing OF dbCalndr.mCal.mHelp;
        PROPERTY ;
            HELPFILE      "DBASE1.HLP",;
            HELPID        "20511",;
            ONCLICK        IDEHelp,;
            ONHELP         IDEHelp,;
            STATUSMESSAGE [Get help on the calendar],;
            TEXT          [&Using]
            
    DEFINE MENUITEM mSep OF dbCalndr.mCal.mHelp;
        PROPERTY ;
            ENABLED   .F.,;
            SEPARATOR .T.        

    * define the about option of the help menu
    DEFINE MENUITEM mAbout OF dbCalndr.mCal.mHelp;
        PROPERTY ;
            HELPFILE      "DBASE1.HLP",;
            HELPID        "20511",;
            ONCLICK        CHAbout,;
            ONHELP         IDEHelp,;
            STATUSMESSAGE [About the calendar],;
            TEXT          [&About]
            
    * displays month and year, and previous/next month buttons
    DEFINE TEXT CalMth OF m->dbCalndr AT kTop,5;
        PROPERTY ;
            LABEL       .F.,;
            TEXT         dbCalndr.cMYStr,;
            COLORNORMAL "B+/W"

    * displays the titles for the days of the week
    DEFINE TEXT CalDays OF m->dbCalndr AT kTop + 2,2;
        PROPERTY ;
            LABEL       .F.,;
            TEXT        [Su  Mo  Tu  We  Th  Fr  Sa],;
            WIDTH        26,;
            COLORNORMAL "W+/W"

    * displays the first week of the month
    DEFINE TEXT Week1 OF m->dbCalndr AT kTop + 3,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[1]

    * displays the second week of the month
    DEFINE TEXT Week2 OF m->dbCalndr AT kTop + 4,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[2]

    * displays the third week of the month
    DEFINE TEXT Week3 OF m->dbCalndr AT kTop + 5,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[3]

    * displays the forth week of the month
    DEFINE TEXT Week4 OF m->dbCalndr AT kTop + 6,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[4]
            
    * displays the fifth week of the month
    DEFINE TEXT Week5 OF m->dbCalndr AT kTop + 7,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[5]

    * displays the sixth week of the month
    DEFINE TEXT Week6 OF m->dbCalndr AT kTop + 8,2;
        PROPERTY ;
            LABEL .F.,;
            TEXT   dB5___wk[6]
            
    * displays today's date in reverse colors
    DEFINE TEXT Today OF m->dbCalndr;
        PROPERTY ;
            LABEL .F.,;
            TEXT        " ",;
            COLORNORMAL "N/G"

    DEFINE TEXT tNext OF m->dbCalndr;
        PROPERTY ;
            LABEL .F.,;
            TEXT  "",;
            TOP    kTop,;
            LEFT   20
            
    DEFINE TEXT tPrev OF m->dbCalndr;
        PROPERTY ;
            LABEL .F.,;
            TOP    kTop,;
            TEXT  "",;
            LEFT   23

